%Scr10_1
f=10.^linspace(0,5.3,10000);
%
s=2*pi*f;

Mo=-198;
%
Rm = 246;
Lm = 2.3e-3; Cm = 2.27e-9;
Co = 7.5e-9;
cd = 3.5;
%
fr=1/(2*pi*sqrt(Lm*Cm));
sfr=2*pi*fr;
%
ZLm=i*s*Lm;
ZCm=1./(i*s*Cm);
ZCo=1./(i*s*Co);
%
Zm=(Rm+ZLm+ZCm);
Zh=Zm.*ZCo./(Zm+ZCo);
%
% diffraction effect
D=1./(sqrt(1+(f/fr*cd).^2));
%
% for admittance plot
Yh=1000./Zh;
T1=ZCo./(Zm+ZCo); 
V1=T1./abs(T1(1)).*10.^(Mo/20).*D;

%grahics
%
% is from D/70 leaflet
img=imread('../PAM_BOOK_data/D70_Admittance_n.tif');

ifx=f>50000 &  f<100000;
xx=f(ifx)/1000; xx=xx-xx(1);
yy1=real(Yh(ifx));
yy2=imag(Yh(ifx));
uu=57+xx*(407-57)/50;
vv1=257+yy1*(56-257)/5;
vv2=257+yy2*(56-257)/6;

figure(1)
clf
%image(img)
imagesc(img(:,:,2)),caxis([96 255])
colormap(gray)
line(uu,vv1,'linewidth',3,'Color','k','linestyle',':');
line(uu,vv2,'linewidth',3,'Color','k','linestyle','--');
set(gca,'visible','off')
%
% is from D/70 leaflet
img=imread('../PAM_BOOK_data/D70_Sensitivity_n.tif');

ifx=f>1000 &  f<200000;
xx=log10(f(ifx)/1000); xx=xx-xx(1);
yy=20*log10(abs(V1(ifx)));

uv=[86.8 325;562.5 71];
xy=[0 -250; 3 -150];

uu=uv(1,1)+(xx-xy(1,1))*(uv(2,1)-uv(1,1))/(xy(2,1)-xy(1,1));
vv=uv(1,2)+(yy-xy(1,2))*(uv(2,2)-uv(1,2))/(xy(2,2)-xy(1,2));

figure(2)
clf
%image(img)
imagesc(img(:,:,2)),caxis([96 255])
colormap(gray)
line(uu,vv,'linewidth',3,'Color','k','linestyle','--');
set(gca,'visible','off')
