%Scr10_2
f=10.^linspace(0,5.3,10000);
%
s=2*pi*f;

Mo=-198;
%
Rm = 246;
Lm = 2.3e-3; Cm = 2.27e-9;
Co = 7.5e-9;
cd = 3.5;
%
fr=1/(2*pi*sqrt(Lm*Cm));
sfr=2*pi*fr;
%
ZLm=i*s*Lm;
ZCm=1./(i*s*Cm);
ZCo=1./(i*s*Co);
%
Zm=(Rm+ZLm+ZCm);
Zh=Zm.*ZCo./(Zm+ZCo);
%
% diffraction effect
D=1./(sqrt(1+(f/fr*cd).^2));

%
R1=1.5e+6; %hydrophone load resistance
%R1=1.5e+4; %alternative hydrophone load resistance

Zo=R1*ZCo./(R1+ZCo);
%
T1=Zo./(Zo+Zm);
T2=Zh./(Zh+R1);
%
%ambient noise
fkz=f/1000;
SD=0; %0:3
w=0; %m/s
%
T=13; %temperature
S=38; %salinity
z=100; %depth
c=1500; %sound speed
pH=7.8; %acidity
aa=FrancoisGarrison(fkz,T,S,z,c,pH);
dcorr=aa*z/1000;

NL1=17-30*log10(fkz);
NL2=44+23*log10(w+1)-17*log10(max(1,fkz));
NL3=30+10*SD-20*log10(max(0.1,fkz));
NL4=-15+20*log10(fkz);

NL3d=NL3-dcorr-10*log10(1+dcorr/8.686);

Na=10.^(NL1/10)+10.^(NL2/10)+10.^(NL3d/10)+10.^(NL4/10);
NL=10*log10(Na);

%FET noise  model
en=0.3e-9;
in=0.2e-12;

%noise estimation
k=1.38e-23;
T=290;
vn= @(R) sqrt(4*k*T*R);
%
V_E=abs(T1).*(1+Co/Cm).*D.*10.^((Mo+NL)/20);
V_H=abs(T1).*vn(Rm);

V_R=abs(T2).*vn(R1);
V_I=abs(T2).*in*R1;
V_N=en+0*f;

V_sys=sqrt(V_N.^2+V_I.^2+V_R.^2+V_H.^2);

figure(1)
hp=plot(f,V_E,'k', f,V_sys,'k',...
        f,V_R,'k-.',...
        f,V_H,'k:', f,V_N,'k--');

set(hp(2:5),'linewidth',2)
set(gca,'xscale','log','yscale','log')
legend('V_E','V_{sys}','V_{R_1}','V_H','e_n',1)
xlabel('Frequency [Hz]')
ylabel('noise voltage [V/sqrt(Hz)')
grid on
set(gca,'xminorgrid','off','yminorgrid','off')
