%Scr1_1
r=1:0.1:100; % range in km
t=10:10:50;  % time steps in seconds
c=1.5; %sound speed in units of km/s
%
P0=1;
s=2;
%
P=zeros(length(r),length(t)); %pre-allocate pressure vector
%
for ii=1:length(t)
   P(:,ii)=P0*exp(-0.5*((c*t(ii)-r)/s).^2)./r; %Eq 1.21
end
%
figure(1)
plot(r,P,'k')
xlabel('Distance r [km]')
ylabel('Pressure P [rel]')
text(20,0.065,'t=10 s')
text(30,0.036,'t=20 s')
text(45,0.025,'t=30 s')
text(60,0.020,'t=40 s')
text(75,0.016,'t=50 s')

