%Scr2_10
% simulate synthetic signal
Ao=sqrt(2); fs=384; fo=50.01; dt=1/fs; tmax=10;
tt=(0:dt:tmax-dt)';
xx=Ao*cos(2*pi*fo*tt);
 
%define windows
wo=ones(floor(length(xx)),1);
w1=[hann(32); zeros(length(xx)-32,1)];
w2=[hann(128); zeros(length(xx)-128,1)];
 
%cut time series
zo=xx.*wo;
z1=xx.*w1;
z2=xx.*w2;
 
% estimate spectral power
nfft=length(wo);
po=2*abs(fft(zo,nfft)).^2/(nfft*sum(wo.^2));
p1=2*abs(fft(z1,nfft)).^2/(nfft*sum(w1.^2));
p2=2*abs(fft(z2,nfft)).^2/(nfft*sum(w2.^2));
 
%plot results
fr=(0:nfft-1)*fs/nfft;
ifr=fr<fs/2;
 
figure(1)
plot(fr(ifr),10*log10(po(ifr)),'k:',...
     fr(ifr),10*log10(p1(ifr)),'k--',...
     fr(ifr),10*log10(p2(ifr)),'k','linewidth',2)
grid on
xlabel('Frequency [kHz]')
ylabel('Spectrum [dB]')
legend('Rect','Hann(32)','Hann(128)')
% obtain some numbers
% RMS value (using time series)
rms_x=sqrt(mean(xx.^2));
 
%integrate spectral power
rms_so=sqrt(sum(po(ifr)));
rms_s1=sqrt(sum(p1(ifr)));
rms_s2=sqrt(sum(p2(ifr)));
 
%peak level of spectral power
pko=max(10*log10(po(ifr)));
pk1=max(10*log10(p1(ifr)));
pk2=max(10*log10(p2(ifr)));
 
%display rms and peak values
rms_x
[rms_so rms_s1 rms_s2]
[pko pk1 pk2]
