%Scr2_14
root='../pam_book_data/';
fname='G_melasTag3'; tname='G_melas'; xl=[0.9 0.95]; xl1=[0.92 0.93];

[xx,fs]=wavread([root fname]);
tt=(0:length(xx)-1)'/fs;
xsel=tt>xl(1) & tt<xl(2);
xx1=xx(xsel,1);
tt1=tt(xsel);
%
% EMD signal decomposition
Nimf=10;
iimax=100;
[C,R,N] = EMD(tt1,xx1,Nimf,iimax);

figure(1)
set(gcf,'position',[100 100 560 680]);
ifg=1;
plotEMD(ifg,tt1,C,N,xl1)

% compare IMFs with original
xl3=0.91192+[0 0.00095];
figure(2)
subplot(211)
plot(tt1,xx1,'k','linewidth',2),xlim(xl3),grid
set(gca,'xticklabel',[])
subplot(212)
plot(tt1,C(:,1),'k'),xlim(xl3),grid
line(tt1,C(:,2),'color','k','linestyle','--'),xlim(xl3),grid
line(tt1,sum(C(:,1:2),2),'color','k','linewidth',2)
xlabel('Time [s]')

% spectral analysis of EMD
[Po,F]=psd(xx1,[],fs/1000);
P1=psd(C(:,1),[],fs/1000);
P2=psd(sum(C(:,1:2),2),[],fs/1000);

figure(3)
plot(F,10*log10(abs(Po)),'k','linewidth',2)
line(F,10*log10(abs(P1)),'color','k','linestyle',':')
line(F,10*log10(abs(P2)),'color','k')
xlabel('Frequency [kHz]')
ylabel('Power spectrum [dB]')
