%Scr2_7
if ~exist('ifl'), ifl=1; end

%pulseFFT
r=20; % center location [km]
c=1.5; % sound speed [km/s]
lam=10; % signal wavelength [km]
sig=4; % Gaussian pulse width

% signal frequency [Hz]
fo=c/lam;
omo=2*pi*fo;

%sampling frequency [Hz];
fs=5; 
%time vector for sampling pressure
t=0:(1/fs):25;
% sampled Gaussian pulse
Pt=exp(-1/2*((c*t-r)/sig).^2).*...
     cos(2*pi*(c*t-r)/lam);

%frequency vector for Fourier transform
fa=-0.4:0.001:0.4;
% circular frequency
oma=2*pi*fa;
%Gaussian pulse Fourier transform
Fa=1/2*sqrt(2*pi)*sig/c*exp(-i*oma*r/c).*...
    (exp(-sig^2/2*((oma-omo)/c).^2)+...
     exp(-sig^2/2*((oma+omo)/c).^2));

% number of FFT frequencies
if ifl==1
    nfft=256;
else
    nfft=512;
end
% call of FFT 
Fct=fft(Pt,nfft)/fs;
% rotation to center zero frequency
Fc=fftshift(Fct);
% frequence vector for FFT
fc=((0:nfft-1)/nfft-0.5)*fs;

%display results
figure(1)
hp=plot(fa,real(Fa),'k-',fc,real(Fc),'k*-',fc,real(Fc),'ko');
set(hp(2),'linewidth',2)
xlim(0.5*[-1 1])
xlabel('Frequency [Hz]')
ylabel('Fourier Transform')
