%Scr2_8
% number of FFT frequencies
nfft=512;

fname1='../Pam_book_data/sw253a01_010719.wav'; 
sp1='Sperm whale'; xl1=10058+[0 1.5];
[S1,fc1,x1,fs1]=getSpectrum(fname1,nfft,xl1); 
S1=S1-max(S1(2:end));

fname2='../Pam_book_data/zifioSelectScan.wav'; 
sp2='Cuvier''s beaked whale'; xl2=1942+[0 1]; 
[S2,fc2,x2,fs2]=getSpectrum(fname2,nfft,xl2); 
S2=S2-max(S2(2:end));

fname3='../Pam_book_data/T0003217_scan_for_ranging.wav'; 
sp3='Bottlenose Dolphin'; xl3=476.3+[0 0.1];
[S3,fc3,x3,fs3]=getSpectrum(fname3,nfft,xl3); 
S3=S3-max(S3(2:end));

fname4='../Pam_book_data/Phocoena.wav'; 
sp4='Harbor porpoise'; xl4=[0.2 0.7]; 
[S4,fc4,x4,fs4]=getSpectrum(fname4,nfft,xl4); 
S4=S4-max(S4(2:end));

ifr=2:nfft/2+1;
figure(1)
hp=plot(fc1(ifr),S1(ifr),'k-',...
        fc2(ifr),S2(ifr),'k-',...
        fc3(ifr),S3(ifr),'k--',...
        fc4(ifr),S4(ifr),'k--','linewidth',2);
set(hp(2),'color',0.5*[1 1 1])
set(hp(4),'color',0.5*[1 1 1])
ylim([-50 0])
xlabel('Frequency [kHz]')
ylabel('Spectrum [dB]')
legend('Pm','Zc','Tt','Pp',0);

fmax1=fc1(find(S1(ifr)==max(S1(ifr))));
fmax2=fc2(find(S2(ifr)==max(S2(ifr))));
fmax3=fc3(find(S3(ifr)==max(S3(ifr))));
fmax4=fc4(find(S4(ifr)==max(S4(ifr))));
res=[fmax1,fmax2,fmax3,fmax4]
