%Scr2_9
[xx,fs] = wavread('../Pam_book_data/zifioSelectScan.wav');
tt=(0:length(xx)-1)/fs;
fsk=fs/1000;
%
%extract single click
dts=0.25;
tso=1.94215;
ts=tso+[-1 1]*dts/1000;
%
tsel=tt>ts(1) & tt<ts(2);
tt1=(tt(tsel)-tso)*1000;
xx1=xx(tsel);
bias=mean(xx1);
xx1=xx1-bias;
%
% spectrogram
nfft=128;
%Matlab 7.5
%[S,F,T,P] = spectrogram(xx1,hann(32),30,nfft,fsk); 
%M=10*log10(abs(P));
%Matlab 7.0
[B,F,T] = specgram(xx1,nfft,fsk,hann(32),30); 
M=20*log10(abs(B));

%plot spectrogram
figure(1)
imagesc(T-dts,F,M); axis xy
grid on
colormap(1-gray(12))
cl=caxis;
caxis(-20+[-60 0])
%caxis(cl(2)+[-60 0])
hb=colorbar;
set(get(hb,'title'),'string','[dB]')

xlabel('Time [ms]')
ylabel('Frequency [kHz]')
title('Cuvier''s beaked whale click')

%apply window to time series
w1=[0*(1:62)'; hann(32); 0*(1:98)'];
z1=xx1.*w1;
w2=[0*(1:81)'; hann(32); 0*(1:79)'];
z2=xx1.*w2;
w3=[0*(1:100)'; hann(32); 0*(1:60)'];
z3=xx1.*w3;

% get FFT spectra
y1=abs(fft(z1));
y2=abs(fft(z2));
y3=abs(fft(z3));
% construct frequency vector
fr=(0:length(y1)-1)*fsk/length(y1);
ifr=fr<fsk/2;

% obtain frequency of spectral maxima
frmax1=fr(find(y1==max(y1),1,'first'));
frmax2=fr(find(y2==max(y2),1,'first'));
frmax3=fr(find(y3==max(y3),1,'first'));

%plot time series and spectra side by side
figure(2)
set(gcf,'position',[100, 100, 560, 600]) 
subplot(321)
hp=plot(tt1,xx1,'k',tt1,z1,'k'); xlim(tt1([1 end]))
set(hp(2),'linewidth',2)
ylabel('rel. Amplitude')
subplot(322)
plot(fr(ifr),y1(ifr),'k')
text(100,max(y1),sprintf('max = %.1f kHz',frmax1))
subplot(323)
hp=plot(tt1,xx1,'k',tt1,z2,'k'); xlim(tt1([1 end]))
set(hp(2),'linewidth',2)
ylabel('rel. Amplitude')
subplot(324)
plot(fr(ifr),y2(ifr),'k')
text(100,max(y2),sprintf('max = %.1f kHz',frmax2))
subplot(325)
hp=plot(tt1,xx1,'k',tt1,z3,'k'); xlim(tt1([1 end]))
set(hp(2),'linewidth',2)
xlabel('Time [ms]')
ylabel('rel. Amplitude')
subplot(326)
plot(fr(ifr),y3(ifr),'k')
text(100,max(y3),sprintf('max = %.1f kHz',frmax3))
xlabel('Frequency [kHz]')
