%Scr3_1
DIa=25;
%
kam=10^(DIa/20);
kas=kam/4;
%
ka=(kam+(-floor(3*kas):ceil(3*kas)))';
%
dth=0.1;
th=0:dth:90; 
%
aa=ka*sin(th/180*pi); 
bb0=piston(aa); 
 
wwo=exp(-((ka-kam)/kas).^2);
ww=wwo*ones(size(th));
 
bbm=mean(ww.*bb0.^2)./mean(ww);
 
ibm=find(ka==kam);
 
DI1=2*sum(sin(th/180*pi))/sum(bb0(ibm,:).^2.*sin(th/180*pi));
DIm=2*sum(sin(th/180*pi))/sum(bbm.*sin(th/180*pi));
 

% approximation of beam pattern 
cx=0.218*kam*sin(th*pi/180);
DLx= 47*cx.^2./(1+abs(cx)+cx.^2);
bpx=10.^(-DLx/10);
%
% convert to dB
DL0=-20*log10(abs(bb0(ibm,:)));
DLb=-10*log10(abs(bbm));
DIx=2*sum(sin(th/180*pi))/sum(bpx.*sin(th/180*pi));

figure(1)
plot(th,DL0,'k')
line(th,DLb,'color','k','linewidth',2,'linestyle','--')
line(th,DLx,'color','k','linewidth',2)
ylim([0 50]);
set(gca,'ydir','rev')
xlabel('Off-axis angle [ ^o]')
ylabel('Off-axis attenuation [dB]')
 
title(sprintf('DIm = %.1f dB;  kam = %.1f;  kas = %.1f',...
      DIa,kam,kas))
 
legend(['DI_{NB_ }: ' sprintf('%.1f dB',10*log10(DI1))],...
       ['DI_{BB_m}: ' sprintf('%.1f dB',10*log10(DIm))],...
       ['DI_{BB_a}: ' sprintf('%.1f dB',10*log10(DIx))]);
