%Scr3_2
freq=40000; rmax=6.1;
%freq=15000; rmax=30.1;
%freq=3000; rmax=100.1;
%source depth
sd=600;

%plot parameters
ncol=15; %number of colors
dBs = 10; %dB/step
%cmap=flipud(jet(ncol));
cmap=gray(ncol);

%receiver depth [m]
rd=0:10:2500;

% sound speed profile
month=8;
lat0=41;
lng0=5;
%    

[sv,T,S]=getSoundSpeed(month,lat0,lng0);

BOT.depth=2000;
BOT.dens=2.4;
BOT.pSpeed=3000;
BOT.pAtt=0.1; %dB/lambda

% extend sv if necessary
if rd(end)>BOT.depth
    sv(end+1,1)=BOT.depth;
    sv(end,2)=sv(end-1,2)+(sv(end,1)-sv(end-1,1))/64.1;
end

%describe bottom
rng=linspace(0,rmax,501)';
bty=[rng, 2000+0*rng];
%
ang=-89:89;
[pressure,Pos]=doBellhop(freq,sv,BOT,sd,rd,bty,ang);

pressure(pressure==0)=1e-38;
RL=-20*log10(abs(squeeze(pressure)));

save(sprintf('TL%.0f',freq),'pressure','Pos');

figure(1)
clf
set(gcf,'PaperOrientation','landscape');
set(gcf,'PaperPositionMode','auto');
set(gcf,'position',[100 300 860 330]);
%sv profile -----------------------------
ax1=axes('units','pixel','position',[60,40,100,250]);
plot(sv(:,2),sv(:,1),'k.-'), axis ij,grid on
xlabel('Sound speed [m/s]')
ylabel('Depth [m]')
ylim(rd([1 end]))
%RL image -------------------------------
ax2=axes('units','pixel','position',[200,40,610,250]);
hold off
hi=imagesc(Pos.r.range/1000,Pos.r.depth,RL);
caxis( [0 ncol*dBs] )
set(gca,'yticklabel',[])
title('Transmission Loss','interpreter','none')
colormap(cmap)
xlabel('Range [km]')
%
hc=colorbar;
set(hc,'units','pixel','position',[820 40 10 250])
set(get(hc,'title'),'string',' dB')
set(hc,'ydir','reverse')
%
hold on
plot(bty(:,1),bty(:,2),'k','linewidth',2)
hold off
