%Scr3_3
rd=100;
%load Bellhop TL file
%[titleText, plottype, freq, atten, Pos, pressure ] = read_shd_bin( 'SHDFIL');
% needs TL file 'TL40000'
% if necessary execute Scr3_2 for frequency 40000
% and save data according to "save('TL40000','pressure','Pos')"
load('TL40000'); rmax=6100; freq=40000;
%
sd=Pos.s.depth;
%
D=[];
for ii=1:length(rd)
    ird=find(Pos.r.depth==rd(ii));
    D(ii).pp=squeeze(pressure(1,1,ird,:));
    D(ii).dd=Pos.r.range;
    ipp=find(D(ii).pp==1e-38);
    D(ii).pp(ipp)=[];
    D(ii).dd(ipp)=[];
    D(ii).rng=sqrt(D(ii).dd.^2+(sd-rd(ii)).^2);
end
%
%Bellhop Thorpe attenuation to compare with Bellhop
Alpha = @(f2) 40.0 * f2 / ( 4100.0 + f2 ) + 0.1 * f2 / ( 1.0 + f2 );
aa=Alpha((freq/1000)^2);
%
y1=@(r,a) 20*log10(r)+a*r/1000;
y2=@(r,a) 10*log10(r)+a*r/1000;

figure(1)
plot(D(1).dd,10-20*log10(abs(D(1).pp)),'k',...
     D(1).dd,10+ y1(D(1).rng,aa),'k--',...
     D(1).dd,10+y2(D(1).rng,aa),'k:',...
     'linewidth',2)
legend('100 m Bellhop',...
    '100 m spherial',...
    '100 m cylidrical',...
    0)
grid
xlim([0 rmax])
xlabel('Horizontal Range [m]')
ylabel('Transmission loss [dB]')
