%Scr3_4
rd=100;
%The following files are generated by Scr3_2 with different frequencies
%and saved with "save('TL3000','pressure','Pos')", etc.
TL1=load('TL3000'); %generated by scr3_2 
TL2=load('TL15000');
TL3=load('TL40000');

%Bellhop Thorpe attenuation to compare with Bellhop
Alpha = @(f2) 40.0 * f2 / ( 4100.0 + f2 ) + 0.1 * f2 / ( 1.0 + f2 );
%
sd(1)=TL1.Pos.s.depth;
sd(2)=TL2.Pos.s.depth;
sd(3)=TL3.Pos.s.depth;
%
D=[];
ii=1;
    D(ii).fr=3000;
    ird=find(TL1.Pos.r.depth==rd);
    D(ii).pp=squeeze(TL1.pressure(1,1,ird,:));
    D(ii).dd=TL1.Pos.r.range;
ii=2;
    D(ii).fr=15000;
    ird=find(TL2.Pos.r.depth==rd);
    D(ii).pp=squeeze(TL2.pressure(1,1,ird,:));
    D(ii).dd=TL2.Pos.r.range;
ii=3;
    D(ii).fr=40000;
    ird=find(TL3.Pos.r.depth==rd);
    D(ii).pp=squeeze(TL3.pressure(1,1,ird,:));
    D(ii).dd=TL3.Pos.r.range;

for ii=1:3
    ipp=find(D(ii).pp==1e-38);
    D(ii).pp(ipp)=[];
    D(ii).dd(ipp)=[];
    D(ii).rng=sqrt(D(ii).dd.^2+(sd(ii)-rd).^2);
    D(ii).aa=Alpha((D(ii).fr/1000).^2);
end
%
%
TLs=@(r,a) 20*log10(r)+a*r/1000;
TLa=@(r,c,a) c*log10(r)+a*r/1000;
TLm=@(r,ro,c,a) 20*log10(min(r,ro))+c*log10(max(1,r/ro))+a*r/1000;

figure(1)
hp=plot(D(1).dd/1000,-20*log10(abs(D(1).pp)),'k',...
        D(2).dd/1000,-20*log10(abs(D(2).pp)),'k',...
        D(3).dd/1000,-20*log10(abs(D(3).pp)),'k',...
        ...
        D(1).dd/1000, TLm(D(1).rng,300,14,D(1).aa),'k--',...
        D(2).dd/1000, TLa(D(2).rng,18.5,D(2).aa),'k--',...
        D(3).dd/1000, TLa(D(3).rng,19.5,D(3).aa),'k--',...
        'linewidth',2);
grid
set(hp(1:3),'color',0.5*[1 1 1]);
tx=text(20,75,'3 kHz: 20log(min(r,300)) +14log(max(1,r/300)) +0.18*r/1000',...
    'color','k','backgroundcolor',[1 1 1],'fontweight','bold');
tx=text(25,125,'15 kHz: 18.5log(r) +2.18*r/1000',...
    'color','k','backgroundcolor',[1 1 1],'fontweight','bold');
tx=text(10,145,'40 kHz: 19.5log(r) +11.33*r/1000',...
    'color','k','backgroundcolor',[1 1 1],'fontweight','bold');

xlabel('Horizontal Range [km]')
ylabel('Transmission loss [dB]')
