%Scr3_6
f=(1:200000)';
fkz=f/1000;

D=0; %0:3 %quiet shipping
w=0; %m/s % no wind.
%
T=13;
S=38;
Z=100;
c=1500;
pH=7.8;
aa=FrancoisGarrison(fkz,T,S,Z,c,pH);
dcorr=aa*Z/1000;

NL1=17-30*log10(fkz);
NL2=44+23*log10(w+1)-17*log10(max(1,fkz));
NL3=30+10*D-20*log10(max(0.1,fkz));
NL4=-15+20*log10(fkz);

NL3d=NL3-dcorr-10*log10(1+dcorr/8.686);

NL=10*log10(10.^(NL1/10)+10.^(NL2/10)+...
            10.^(NL3d/10)+10.^(NL4/10));

figure(1)
hp=plot(f,[NL1 NL2 NL3d NL4 NL],'k','linewidth',1);
set(hp(1),'linestyle','-')
set(hp(2),'linestyle',':')
set(hp(3),'linestyle','--')
set(hp(4),'linestyle','--')
set(hp([2 3 5]),'linewidth',2)
ylim([0 80])
grid on
ylabel('Spectral noise level [dB re 1 \muPa^2/Hz]')
xlabel('Frequency [Hz]')
set(gca,'xscale','log','xminorgrid','off')
legend('NL_{Turb}','NL_{Surf}','NL_{Ship}',...
       'NL_{Therm}','NL_{Tot}')
return
