%Scr4_10
root='../pam_book_data/';
fname='right whale example.wav'; %pamguard examples
tname='E_glacialis';
%
[xx,fs]=wavread([root fname]);
xx=xx(:,1);
tt=(0:length(xx)-1)'/fs;
%
ss=xx-mean(xx);
%
%orginal spectrogram
[Bo,F,T]=specgram(ss,1024,fs,hann(256),192);
%
figure(1)
clf
imagesc(T,F/1000,20*log10(abs(Bo))), axis xy
colormap(1-gray)
cl=caxis;
caxis(cl(2)+[-40 0])
xp=[0.28 0.38 0.48 0.55 0.66 0.76]
for ii=1:length(xp)
annotation('arrow',xp(ii) + [0 0], 0.4+[0.1 0])
end
%return
%
% generating a synthetic right whale up call
qq=[0.025 0.02 0.05 0.07];
tr=31.9:0.1:33.6;
xl=[31 34];

dt=1/fs;
tt_r=(0:dt:(tr(end)-tr(1)))';
ff_r=polyval(qq.*[1/4 1/3 1/2 1],tt_r);
nw=length(tt_r);
R = hann(nw).*exp(-2*pi*i*ff_r.*tt_r*1000); 

% call matched filter
%using fftfilt to match filter the data
y=fftfilt(flipud(R),[ss;zeros(floor(nw),1)]); y(1:floor(nw))=[];

%filtered spectrogram
[B2,F,T]=specgram(real(y),1024,fs,hann(256),192);

figure(2)
subplot(221)
plot(tt,ss,'k')
ylabel('Amplitude')
xlim(xl)
subplot(222)
plot(tt,abs(y),'k')
xlim(xl)
subplot(223)
imagesc(T,F/1000,20*log10(abs(Bo))), axis xy
hold on
plot(tr,polyval(qq,(tr-tr(1)))+0.02,'k','linewidth',2)
hold off
colormap(1-gray)
cl=caxis;
caxis(cl(2)+[-40 0])
ylabel('Frequency [kHz]')
xlabel('Time [s]')
xlim([31 34])
ylim([0 0.5])
subplot(224)
imagesc(T,F/1000,20*log10(abs(B2))), axis xy
colormap(1-gray)
cl=caxis;
caxis(cl(2)+[-40 0])
xlabel('Time [s]')
xlim([31 34])
ylim([0 0.5])

figure(3)
subplot(211)
plot(tt,ss,'k')
ylabel('Amplitude')
xlim(tt([1 end]))
subplot(212)
plot(tt,abs(y),'k')
xlim(tt([1 end]))
ylabel('MFilt output')
xlabel('Time [s]')
