%Scr5_1
%
%Cluster analysis
% Simulation
% simulated samples per cluster
%   Pm, Zc, Tt, Pp
nc=[60  50  70  40];
% assumed centoids
mc=[0.1  0.2  0.05  0.2; %length
    15   40    30   120; %centerfrequency
     5    10   30     5]; %bandwidth
% assumed sigmas
sc=[0.01 0.02 0.005 0.01; %length
    1.5   4     3     10; %centerfrequency
     1    2     4      1]; %bandwidth
%
xx=[];
randn('state',0);
for ii=1:length(nc)
    xx=[xx;ones(nc(ii),1)*mc(:,ii)'+(ones(nc(ii),1)*sc(:,ii)').*randn(nc(ii),size(mc,1))];
end
 
% Z-transform
zz=doTrans(xx);
 
%
%
Kmax=10;
F=zeros(Kmax,1);
FW=zeros(Kmax,1);
FB=zeros(Kmax,1);
for K=2:Kmax;
    % do cluster analysis for K clusters
    np=doCluster(zz,K);
    %cluster parameters
    [cm,cv,kct]=doCentroids(zz,np);
    [F(K),FW(K),FB(K)]=doFcrit(zz,np,cm,kct);
end

% find best number of clusters
K=find(F==max(F));
np=doCluster(zz,K);
%
%cluster parameters for original samples
[cm,cv,kct]=doCentroids(xx,np);
% display numbers
[kct;cv;cm]
% 
% plot results
figure(1)
plot3(xx(:,1),xx(:,2),xx(:,3),'k.')
grid on
for ii=1:length(cm)
text(cm(1,ii)+0.05,cm(2,ii),cm(3,ii)-2,...
    sprintf('Class %d',ii),'backgroundcolor','w')
end
 
cp=[-0.012   -4.18    0.84]*1000;
set(gca,'CameraPosition',cp)
box on
xlabel('Length')
ylabel('Peak Frequency')
zlabel('Bandwidth')
