%Scr5_2
% load data
if 1
    [xx,fs] = wavread('../Pam_book_data/zifioSelectScan.wav');
else
    [xx,fs] = wavread('../Pam_book_data/zifioSelectLong.wav');
end
%
% construct time vector
tt = (1:length(xx))'/fs;
%
% subtruct mean to remove constant offset
ss = xx - mean(xx);
clear xx
%
%calibrate time series
%cal=10^(147/20); %unit is equiv 147 dB re 1 uPa
cal=10^(27/20); %unit is equiv 27 dB re 1 Pa
ss=cal*ss;

bb=3;
if bb==1
    %broadband bp filter
    tic
    df1=[20 60]/fs*2000; %pass-band
    df2=[10 100]/fs*2000; %stop-band
    xx3=BP_filter(ss,df1,df2);
    nn3=sqrt(mean(abs(xx3).^2));
    snr3 = abs(xx3)/nn3;
    toc
    dat=xx3;
    snr=snr3;
elseif bb==2
    %narrow bp filter
    tic
    df1=[37 43]/fs*2000; %pass-band
    df2=[30 50]/fs*2000; %stop-band
    xx3=BP_filter(ss,df1,df2);
    nn3=sqrt(mean(abs(xx3).^2));
    snr3 = abs(xx3)/nn3;
    toc
    dat=xx3;
    snr=snr3;
elseif bb==3
    %equalization
    tic
    [b1,a1]= butter(2, 2*45000/fs, 'high');
    [b2,a2]= butter(2, 2*120000/fs, 'low');
    yy1=filter(b1,a1,ss);
    yy2=filter(b2,a2,yy1);
    
    xx2=doAnalytic(yy2,512);
    nn2=sqrt(mean(abs(xx2).^2));
    snr2 = abs(xx2)/nn2;
    toc
    dat=xx2;
    snr=snr2;
end

th=4.5;
dt_max=2e-3;
%
[jth,i1,i2]=do_SimpleDetection1(snr,tt,th,dt_max);
%
ifl=find(i2-i1<3);
jth(ifl)=[];
i1(ifl)=[];
i2(ifl)=[];
%
%extract features 
di=ceil(fs*1e-4);
ff=(0:1023)'/1024*fs/1000;
iff=ff<fs/2000;
Det=[];
for ii=1:length(jth)
    jj=i1(ii):i2(ii);
    xxs=abs(dat(jj));
    cee=sum(xxs.^2); %integrated power squared
    %
    Det(ii,1)=sum(tt(jj).*xxs.^2)/cee;
    Det(ii,2)=10*log10(cee);
    Det(ii,3)=10*log10(max(xxs.^2))-Det(ii,2);
    Det(ii,4)=sqrt(sum((tt(jj)-Det(ii,1)).^2.*xxs.^2)/cee)*10^6;
    %
    yy=abs(fft(dat(jj),1024)); yy=yy(:);
    csp=sum(yy(iff).^2);
    %
    Det(ii,5)=sum(ff(iff).*yy(iff).^2)/csp;
    Det(ii,6)=sqrt(sum((ff(iff)-Det(ii,5)).^2.*yy(iff).^2)/csp);
    Det(ii,7)=ff((yy(iff)==max(yy(iff))));
end
%
tcl=tt(jth);
ici=diff(tcl);
pcl=interp1(tt,abs(dat),tcl);

%clustering
%select features
dsel=[3 4 5 6 7];

tic
D=Det(:,dsel);
X=doTrans(D);
Kmax=6;
F=zeros(Kmax,1);
FW=zeros(Kmax,1);
FB=zeros(Kmax,1);
for K=2:Kmax
    np=doCluster(X,K);
    [cm,cv,kct]=doCentroids(D,np);
    [F(K),FW(K),FB(K)]=doFcrit(D,np,cm,kct);
end
%
[d_ Ko]=max(F);
np=doCluster(X,Ko);
[cm,cv,kct]=doCentroids(D,np);
toc

%print table 5.1
[np Det]

figure(1)
plot(tt,abs(dat),'k',tcl(np==1),pcl(np==1),'ko',tcl(np==2),pcl(np==2),'ks')
xlim(tt([1 end]))
xlabel('Time [s]')
ylabel('Pressure [Pa]')
legend('Data','class 1','class 2')
