%Scr5_3
% load data
[xx,fs] = wavread('../Pam_book_data/ZifioSelectLong.wav');
%
% construct time vector
tt = (1:length(xx))'/fs;
%
% subtruct mean to remove constant offset
ss = xx - mean(xx);
clear xx
%
%calibrate time series
%cal=10^(147/20); %unit is equiv 147 dB re 1 uPa
cal=10^(27/20); %unit is equiv 27 dB re 1 Pa
ss=cal*ss;

bb=3;
if bb==1
    %broadband bp filter
    tic
    df1=[20 60]/fs*2000; %pass-band
    df2=[10 100]/fs*2000; %stop-band
    xx3=BP_filter(ss,df1,df2);
    nn3=sqrt(mean(abs(xx3).^2));
    snr3 = abs(xx3)/nn3;
    toc
    dat=xx3;
    snr=snr3;

elseif bb==2
    %narrow bp filter
    tic
    df1=[37 43]/fs*2000; %pass-band
    df2=[30 50]/fs*2000; %stop-band
    xx3=BP_filter(ss,df1,df2);
    nn3=sqrt(mean(abs(xx3).^2));
    snr3 = abs(xx3)/nn3;
    toc
    dat=xx3;
    snr=snr3;

elseif bb==3
    tic
    [b1,a1]= butter(2, 2*45000/fs, 'high');
    [b2,a2]= butter(2, 2*120000/fs, 'low');
    yy1=filter(b1,a1,ss);
    yy2=filter(b2,a2,yy1);
    
    xx2=doAnalytic(yy2,512);
    nn2=sqrt(mean(abs(xx2).^2));
    snr2 = abs(xx2)/nn2;
    toc
    dat=xx2;
    snr=snr2;
end

th=4.5;
dt_max=2e-3;
%
[jth,i1,i2]=do_SimpleDetection1(snr,tt,th,dt_max);

if 0
figure(1)
clf
plot(tt,snr,'k',tt(jth),snr(jth),'ko',...
     tt([1 end]),th*[1 1],'k--')
return
end

ifl=find(i2-i1<3);
jth(ifl)=[];
i1(ifl)=[];
i2(ifl)=[];
%
tcl=tt(jth);
pcl=abs(dat(jth));
%
h=0.1;c=1.5;
dt1=0;
dt2=(2*h)/c; %h is hydrophone depth, c is sound speed
ac=1000;
Hcmin=3;
icm=doDelayHisto(tcl,dt1,dt2,ac,Hcmin);

% doubleton classification
inp=doAllocTrain1(tcl,pcl,icm,ac,dt2);

for ii=1:length(tcl)
    if inp(ii)>0
	  fprintf('%.1f %f\n',inp(ii),tcl(ii))
    end
end

%extract first 
is1=inp(:,1)==1;
is2=inp(:,1)==2;
tcl1=tcl(is1);
tcl2=tcl(is2);

p1=pcl(is1);
p2=pcl(is2);

figure(1)
subplot(211)
plot(tt,abs(dat),'k',tcl1,p1,'ko',tcl2,p2,'ks')
ylim([0 1.1*max(pcl)])
ylabel('Amplitude [Pa]')

subplot(212)
plot(tcl1(2:end),diff(tcl1),'k*', tcl1,tcl2-tcl1,'kd')
ylim([0 1.1*max(diff(tcl1))]);
xlabel('Time [s]')
ylabel('Detay [s]')
legend('ICI','Surf',0)
return
