%Scr5_4
%ifl=2; %1-3
clear jth
if ~exist('jth')
fs=31250;
% load data
fname='../Pam_book_data/275_08_40';
fi=fopen(fname);
  xx=fread(fi,[2,inf],'int16');
fclose(fi);
if size(xx,2)>size(xx,1), xx=xx'; end

% construct time vector
tt = (1:length(xx))'/fs;
%
% subtruct mean to remove constant offset
ss = xx - repmat(mean(xx),size(xx,1),1);
clear xx
%
%calibrate time series
cal=10^(-60/20); %arbitrary
ss=cal*ss;

bb=1;
if bb==1
    %broadband bp filter
    tic
    df1=[1.5 14]/fs*2000;
    df2=[0.1 15]/fs*2000;
    xx3=BP_filter(ss,df1,df2);
%    xx3=doAnalytic(ss,1024);
    nn3=sqrt(mean(abs(xx3).^2));
    snr3 = abs(xx3)./repmat(nn3,size(xx3,1),1);
    toc
    dat=xx3(:,1);
    snr=snr3(:,1);

elseif bb==2
    tic
    [b1,a1]= butter(2, 2*45000/fs, 'high');
    [b2,a2]= butter(2, 2*120000/fs, 'low');
    yy1=filter(b1,a1,ss);
    yy2=filter(b2,a2,yy1);
    
    xx2=doAnalytic(yy2,512);
    nn2=sqrt(mean(abs(xx2).^2));
    snr2 = abs(xx2)/nn2;
    toc
    dat=xx2;
    snr=snr2;
else
    %narrow band STFT filter
    tic
    fo=10000;
    nk=38;
    xx5=STFT_filter(ss,fo/fs,nk);
    nn5=sqrt(mean(abs(xx5).^2));
    snr5 = abs(xx5)/nn5;
    toc
    dat=xx5;
    snr=snr5;
end

th=3.5;
dt_max=4e-3;
%
[jth,i1,i2]=do_SimpleDetection1(snr,tt,th,dt_max);
%
tcl=tt(jth);
dtc=(tt(i2)-tt(i1-1))*1000;
ici=diff(tcl);
pcl=interp1(tt,abs(dat),tcl);
scl=interp1(tt,snr,tcl);

%store in excel spread sheet
if 0
    X=[tcl dtc pcl];
    xlswrite('Pm2Class2',X);
end

end %if 0
%
if ifl==1
figure(1)
clf
hp=plot(tt,snr,'k',tt([1 end]),th*[1 1],'k--',tcl,scl,'k.');
set(hp(1),'color',0.5*[1 1 1]);

xlabel('Time [s]')
ylabel('SNR')
return
end

%
tcl=tt(jth);
pcl=abs(dat(jth));

% input hydrophone depth and sound speed
h=80; c=1500;
%
dt1=0;
dt2=2*h/c; %h is hydrophone depth, c is sound speed
ac=1000;
Hcmin=6;
icm=doDelayHisto(tcl,dt1,dt2,ac,Hcmin);

% doubleton classification
xdx_min=1;
inp=doAllocTrain(tcl,pcl,icm,ac,dt2,xdx_min);

if 0
for ii=1:length(tcl)
    if inp(ii,1)>0
	  fprintf('%d %d %d %f %f\n',ii,inp(ii,:),tcl(ii),(tcl(ii)-tcl(inp(ii,2)))*1000)
    end
end
end

%
inp1=inp(:,1)==1;
inp3=inp(:,1)==3;
tcl1=tcl(inp1);
pcl1=pcl(inp1);
tcl3=tcl(inp3);
pcl3=pcl(inp3);
%
pcli1=interp1([tcl(1); tcl1; tcl(end)],...
              [pcl1(1); pcl1; pcl1(end)],tcl);
pcli3=interp1([tcl(1); tcl3; tcl(end)],...
              [pcl3(1); pcl3; pcl3(end)],tcl);
%
if ifl==2
    figure(1)
    hp=plot(tt,abs(dat),...
        tcl1, pcl1,'k.',tcl3, pcl3,'kd',...
        tcl,pcli1,'k',tcl,pcli3,'k');
    set(hp(1),'color',0.5*[1 1 1]);
    ylim([0 1.1*max(abs(dat))])
    xlabel('Time [s]')
    ylabel('Amplitude [rel]')
    return
end
%
%
npo=inp;
inp=doClickTrain(inp,tcl,pcl,icm,0.15);
%
K=length(icm);
class=doClickTrainClass(inp,tcl,K);
[inp, tcl, pcl, squeeze(class(:,:,1)), squeeze(class(:,:,2))]
%nn

%extract first 
is10=abs(inp(:,1))==1;
is11=abs(inp(:,1))==2;
is20=abs(inp(:,1))==3;
is21=abs(inp(:,1))==4;

tcl1=tcl(is10);
tcl2=tcl(is20);

p1=pcl(is10);
p2=pcl(is20);

ici1=diff(tcl1); ici1(ici1>1.5)=nan;
ici2=diff(tcl2); ici2(ici2>1.5)=nan;

iso=abs(npo(:,1))==3;
tclo=tcl(iso);
po=pcl(iso);
icio=diff(tclo); icio(icio>1.5)=nan;

isoa=abs(npo(:,1))==1;
tcloa=tcl(isoa);
poa=pcl(isoa);
icioa=diff(tcloa); icioa(icioa>1.5)=nan;

if ifl==3
figure(1)
subplot(211)
hp=plot(tt,abs(dat),tcl2,p2,'k.-',tcl1,p1,'kd-',tclo,po,'ko',tcloa,poa,'ko');
set(hp(1),'color',0.5*[1 1 1]);
ylim([0 1.1*max(scl)])
ylabel('Amplitude [rel]')

subplot(212)
plot(tcl2(2:end),ici2,'k.-',tcl1(2:end),ici1,'kd-')
ylim([0 1.5]);
xlabel('Time [s]')
ylabel('ICI [s]')
return
end