%Scr5_5
root='../pam_book_data/';

fname='S_coe_short'; tname='S_coeruleoalba';

clear M
if ~exist('M')
[xx,fs]=wavread([root fname]);
xx=xx(:,1);
tt=(0:length(xx)-1)'/fs;

[B,F,T]=specgram(xx-mean(xx),1024,fs,hann(256),192);

%get spectral power
B2=B.*conj(B);
%
%spectral noise estimation
f1=1000; f2=4000;
if1=find(F>=f1,1,'first');
if2=find(F>=f2,1,'first');
if 0
    n1=mean(10*log10(B2(if1,:)));
    n2=mean(10*log10(B2(if2,:)));
else
    n1=10*log10(mean(B2(if1,:)));
    n2=10*log10(mean(B2(if2,:)));
end

q1=10.^((n2-n1)/20);
am=(q1*f2-f1)/(1-q1);
cm=n1+20*log10(f1+am);

NE=10.^((cm-20*log10((F+am)))/10);

%
%normalize
B3=B2./(NE*ones(size(T')));

%2nd derivative
df=fs/1024;
D2=2*B3(2:end-1,:)-(B3(3:end,:)+B3(1:end-2,:));
D2=[D2(1,:);D2;D2(end,:)];

itm1=find(T>=2.54,1,'first');
itm2=find(T>=0.595,1,'first'); 

%thresholding the 2nd derivative
th=4;
B4=(D2>th).*B2;

%find local maxima in frequency direction
M1=[0*B4(1,:);B4(2:end,:)>B4(1:end-1,:)];
M2=[B4(1:end-1,:)>B4(2:end,:);0*B4(end,:)];
M=M1.*M2; clear M1 M2 % clear intermediate matrices

%localize local maxima
[Mr,Mc]=find(M);

nii=size(B2,1);
njj=size(B2,2);

io=121;
io=651+4;

%result vector
DET=[];
%
tic
ye=[];
dy=[];
ddy=[];
yl=[];
yb=[];
ntr=0;
yn=[];
%
iox=1:size(M,2);
%iox=150:200;%1:1600; %1600 equiv 1.1 s
for io=iox
    ij=Mc==io;
    ymo=Mr(ij);
    %
    [ya ntr]=doAssoc2(ye,ymo,dy,ddy,yl,yb,ntr,11,6);
    %
    ye=ya(:,1);
    ym=ya(:,2);
    dy=ya(:,3);
    ddy=ya(:,4);
    yl=ya(:,5); %track number
    yb=ya(:,6); %idle counter

    % correct actual measurement
    dya=0.5*(ym-ye);
    yc=ye+dya;
    %
    % store actual tracked
    DET=[DET;[io+0*yc, yc, yl, yb dy, ddy]];
    %
    %exponential averaging of prediction step
    ddy=0.8*(dya-dy);
    dy=dy+ddy;
    %predict for next sample
    ye=yc+dy;
end
toc
tic
dt=diff(T(1:2));
lth=0.05/dt;
% clean up short tracks
for ii=1:ntr
    ifl=DET(:,3)==ii;
%    [ii sum(ifl)]
    if sum(ifl)<lth %6+3
        DET(ifl,:)=[];
    end
end
toc
end
%
figure(1)
nc=2;
kk=0;
for ii=min(DET(:,3)):max(DET(:,3))
    ifl=DET(:,3)==ii;
    if sum(ifl)>0
        kk=kk+1;
        line(T(DET(ifl,1)),F(round(DET(ifl,2)))/1000,...
            'color',(mod(kk-1,nc))/nc*[1 1 1],'linewidth',2)
    end
end
%
xlim(T(iox([1 end])))
ylim(F([1 513])/1000)
xlabel('Time [s]')
ylabel('Frequency kHz]')
%
tic
S=[];
Lsnip=20;
mLab=max(DET(:,3));
for ii=1:mLab
    isamp=find(DET(:,3)==ii);
    nsamp=length(isamp);
    if nsamp==0, continue, end
    nsnip=floor(nsamp/Lsnip);
    for jj=1:nsnip-1
        nn=isamp((1+(jj-1)*Lsnip):jj*Lsnip);
        %do a local LMS fit
        uu=DET(nn,1)-T(DET(nn(1),1));
        vv=DET(nn,2);
        qq=polyfit(uu,vv,1);
        S=[S;[qq mean(DET(nn,5))]];
    end
    %take now remaing data of track
    nn=isamp((1+(nsnip-1)*Lsnip):length(isamp));
    uu=DET(nn,1)-T(DET(nn(1),1));
    vv=DET(nn,2);
    qq=polyfit(uu,vv,1);
    S=[S;[qq mean(DET(nn,5))]];
end
toc
%
%use only data from detection tracker
[hy,hx]=hist(S(:,1),50);
dF=(F(2)-F(1))/1000; % kHz
dT=(T(2)-T(1)); %s
figure(2)
hb=bar(hx*dF/dT,hy,1,'facecolor','w','edgecolor','k');
xlabel('Slope [kHz/s]')
ylabel('Histogram frequency [count]')
return
