%Scr6_5
beta=(-180:0.1:180)';
beta0=30;

N=3;
n=(0:N-1)';
%
fc=40; %kHz
sig=0.03; %ms
AL=1; % m
%
om=2*pi*fc;
lo=1.5/fc; %m
L=AL/(N-1);
dl=2*L/lo;
arg=dl*(cos(beta*pi/180)-cos(beta0*pi/180));
%
%rectangular weighting
w0=rectwin(N); w0=w0/sum(w0);
%
bp=beta*[0 0 0];
for ii=1:length(beta)
    arg1=2*n*arg(ii);
    arg2=-0.5*(n*arg(ii)/(om*sig)).^2;
   bp(ii,1)=sum(w0.*exp(arg1));
   bp(ii,2)=sum(w0.*exp(arg2+i*arg1));
   bp(ii,3)=sum(w0.*exp(arg2));
end
bp=abs(bp).^2;
%
figure(1)
set(gcf,'position',[100 100 560 600])
%subplot(211)
subplot('position',[0.1 0.75 0.8 0.2])
tt=-0.2:0.001:0.2;
hp=plot(tt,real(exp(i*om*tt)));
set(hp,'color',0.5*[1 1 1])
line(tt,real(exp(-0.5*(tt/sig).^2+i*om*tt)),...
    'color','k','linewidth',2)
line(tt,real(exp(-0.5*(tt/sig).^2)),...
    'color','k','linewidth',2,'linestyle','--')
set(gca,'fontsize',14)
xlabel('Time [ms]')
%
%subplot(212)
subplot('position',[0.05 0.05 0.6 0.6])
hp=polar(beta*pi/180*[1 1 1],bp);
set(gca,'fontsize',14)
set(hp(1),'color',0.5*[1 1 1],'linewidth',2)
set(hp(2),'color','k','linewidth',2)
set(hp(3),'color','k','linewidth',2,'linestyle','--')
hl=legend('CW','Pulse','Gauss');
xl=get(hl,'position');
set(hl,'position',[0.75 0.4 xl(3:4)])
