%Scr8_1
%
TL=(0:0.1:180)';
%
FOM=116;
%
C1=47;
C2=0.218*17.8;
DL_max=C1*C2^2/(1+C2+C2^2);

%Gaussian weighting
sig=5;
Wx=@(x,xo) ...
    1/(sqrt(2*pi)*sig)*exp(-1/2*((x-xo)/sig).^2);

dx=0.1;
x=0:dx:(FOM+DL_max+4*sig); 
%FOM+DL_max+4*sig is assumed to be infinity
%
g1=0*TL;
for ii=1:length(TL);
    W=Wx(x+TL(ii),FOM-DL_max);
    g1(ii)=sum(W)*dx;
end
%
th=asin(1/(2*C2)*(x./(x-C1))...
    .*real(-sqrt(1-4*((x-C1)./x))-1));
%
th(1)=0; % for x=0;
th(x>=DL_max)=pi; % for x>=DL_max
%
x2=x(x<DL_max);
x3=x(x>=DL_max);
th2=th(x<DL_max);
g2=0*TL;
g3=0*TL;
for ii=1:length(TL)
    W2=Wx(x2+TL(ii),FOM);
    g2(ii)=0.5*sum(W2.*(1-cos(th2)))*dx;
    W3=Wx(x3+TL(ii),FOM);
    g3(ii)=sum(W3)*dx;
end
gr=g3+g2;

%inverting the spherical spreading law
R=1:0.1:6000;
TLR=20*log10(R)+9.5*R/1000;
r=interp1(TLR,R,TL);

y=real(log(-log(1-gr)));
x=log(r);

%yo=log(-log(1-0.6321));
yo=0;
i1=find(y<=yo,1,'first');
alpha=(y(i1)-y(i1-1))/(x(i1)-x(i1-1));
x0=x(i1-1)+(yo-y(i1-1))/alpha;
r0=exp(x0);
%
figure(1)
plot(TL,g3,'k--',TL,g2,'k-')
line(TL,gr,'color','k','linewidth',2)
ylabel('Probability')
xlabel('TL [dB]')
ylim([0 1.1])

figure(2)
plot(r,gr,'k','linewidth',2)
line(r,1-exp(-(r/r0).^alpha),...
    'color','k','linestyle','--','linewidth',2)
ylabel('Probability')
xlabel('Range [m]')
ylim([0 1.1])
title(sprintf('r_0 = %.0f  alpha = %.3f',r0,alpha));
return
