%Scr9_2
NA=100; Rmax=7000;
dr=1; r=0:dr:Rmax;
%
r0=4000; cv=0.2; sig=cv*r0;
rs=r0;
wr0=1/(sqrt(2*pi)*sig)*exp(-0.5*((r-rs)/sig).^2);
 
gr=1-cumsum(wr0)*dr;
%
%simulate animal ranges
na=1.5*NA;
%
rand('state', 2);

% animal ranges
xx=2*Rmax*(rand(na,1)-0.5);
yy=2*Rmax*(rand(na,1)-0.5);

rr=sqrt(xx.^2+yy.^2);
%
rr(rr>Rmax)=[]; rr(NA+1:end)=[];
nr=length(rr); % nr should be NA

% simulate detections
pr=interp1(r,gr,rr);
idets=rand(nr,1)<pr;
%
% keep range of all detections
ri=rr(idets);

% histograms
% ranges of simulated animals
dx=500;
hx=(0:dx:Rmax)';
hy0=histc(rr,hx);
NA_sim=sum(hy0);

% ranges of detected animals
hy=histc(ri,hx);
NA_det=sum(hy);
%
figure(1)
hb=bar(hx+250,hy);xlim([0 7000]),ylim([0 7])
set(gca,'xtick',hx);
set(hb(1),'facecolor','w')
xlabel('Distance [m]')
ylabel('Animal count')
title(...
    sprintf('NA_{sim} = %d       NA_{det} = %d',...
             NA_sim,NA_det))
