%Scr9_3
% abundance estimation
% requires script scr9_2
Scr9_2
% or detection vector ri;
%
r0=4000; cv=0.2; sig=cv*r0;
%
dx=500; Rmax=7000;
hx=(0:dx:Rmax)';
% ranges of simulated animals
hy0=histc(rr,hx);
NA_sim=sum(hy0);
% ranges of detected animals
hy=histc(ri,hx);
NA_det=sum(hy);

% PDFs
wri=@(a,hx)...
    (a*dx)*2*hx/(Rmax^2);
wro=@(hx,r0,sig)...
    1/(sqrt(2*pi)*sig)*exp(-0.5*((hx-r0)/(sig)).^2);
%
mgx=@(b,c,hx)...
    1-cumsum(wro(hx,b,c))*dx;
mfx=@(x,hx)...
    wri(x(1),hx).*mgx(x(2),x(3),hx);
%
%
% estimate model parameters from data
b0=[NA,r0,cv*r0];
b=nlinfit(hx,hy,mfx,b0);
% next line requires Matlab 7.5
%b=nlinfit(hx,hy,mfx,b0,statset('robust','on','WgtFun','logistic'));
 
% Variances
% simulation mismatch
varo=sum((mfx([NA_sim,r0,cv*r0],hx)-hy).^2);
% estimation error variance
var=sum((mfx(b,hx)-hy).^2);
 
figure(1)
hold off
hb=bar(hx,[hy0 hy]);xlim([0 7000]),ylim([0 17])
hold on
plot(hx,wri(b(1),hx),'k--',hx,mfx(b,hx),'k.-')
hold off
set(hb(1),'facecolor',0.9*[1 1 1])
set(hb(2),'facecolor',0.5*[1 1 1])
xlabel('Distance [m]')
ylabel('Animal count')
title(...
sprintf('NA_{est} = %.0f  r_0 = %.1f  sig = %.1f  : var = %f',...
        b,var))
return

