%Scr9_4
NA=100; Rmax=7000;
dr=1; r=0:dr:Rmax;
%
%simulated detection function
r0=4000; cv=0.2; sig=cv*r0;
rs=r0;
wr0=1/(sqrt(2*pi)*sig)*exp(-0.5*((r-rs)/sig).^2);
 
gr=1-cumsum(wr0)*dr;
%
dx=500; hx=(0:dx:Rmax)';

% PDFs
wri=@(a,hx)...
    (a*dx)*2*hx/(Rmax^2);
wro=@(hx,r0,sig)...
    1/(sqrt(2*pi)*sig)*exp(-0.5*((hx-r0)/sig).^2);
%
mgx=@(b,c,hx)...
    1-cumsum(wro(hx,b,c))*dx;
mfx=@(x,hx)...
    wri(x(1),hx).*mgx(x(2),x(3),hx);
%
%simulate animal ranges
nas=2*NA; %factor 2 only to be save
%
% initiate random number generation
rand('state', 2);

% repeat the simulastion 1000 times
Ns=1000;
Na=zeros(Ns,1);
warning 'off' 'stats:nlinfit:IterationLimitExceeded'
warning 'off' 'stats:nlinfit:IllConditionedJacobian'
for ii=1:Ns
% simulate animal ranges
xx=2*Rmax*(rand(nas,1)-0.5);
yy=2*Rmax*(rand(nas,1)-0.5);

rr=sqrt(xx.^2+yy.^2);
%
rr(rr>Rmax)=[]; rr(NA+1:end)=[];
nr=length(rr); % nr should be NA
%
% simulate detections
pr=interp1(r,gr,rr);
idets=rand(nr,1)<pr;
%
% keep range of all detections
ri=rr(idets);

% histograms
% ranges of simulated animals
hy=histc(ri,hx);
NA_det=sum(hy);

%
% estimate model parameters from data
b0=[NA,r0,cv*r0];
b=nlinfit(hx,hy,mfx,b0);%,statset('robust','on','WgtFun','logistic'));
Na(ii)=b(1);
end
warning 'on' 'all'

hx=1:5:400;
[hy,hx]=hist(Na,hx);

figure(1)
bar(hx,hy/sum(hy),1,'facecolor','w')
xlim([0 400])
xlabel('Animal count')
ylabel('PDF')
