%Scr9_5
%
Rmax=7000;
%
vo=1.5; %speed [m/s]
nsim=3600; %number of clicks / dive
%
clear Ho %comment it skip simulation
%
%heading distribution
dg=0.01;
gam=-pi:dg:pi;
k=5;
wg=1/(2*pi*besseli(0,k))*exp(k*cos(gam));
cwg=cumsum(wg)*dg;
%
nrep=10000;
dx=500;
hx=0:dx:Rmax;
%
if ~exist('Ho','var')
    Ho=zeros(length(hx),nrep);
    Hi=zeros(length(hx),nrep);
    tic
    rand('state',1)
    for ii=1:nrep
        % simulate initial track position
        %  randomly located within circle
        ro=inf;
        while ro>Rmax
            rdo=rand(1,2);
            xo=2*Rmax*(rdo(1,1)-0.5);
            yo=2*Rmax*(rdo(1,2)-0.5);
            ro=sqrt(xo^2+yo^2);
        end
        %simulate initial direction
        gamo=2*pi*rand(1,1);
        %
        %simulate animal track
        ncl=rand(nsim,2);

        %simulate animal track
        arg=ncl(:,1);
        icwg=cwg>0.0001 & cwg<0.9999;
        args=gamo+...
            interp1(cwg(icwg),gam(icwg),arg,'lin','extrap');
        %
        %assume constant speed between clicks ans 2 clicks/s
        dro=vo*0.5;
        dxa=dro*cos(args);
        dya=dro*sin(args);
        xx=xo+[0;cumsum(dxa)];
        yy=yo+[0;cumsum(dya)];
        rr=sqrt(xx.^2+yy.^2);
        %
        % keep range distribution of all animals
        hy=histc(rr,hx);
        Ho(:,ii)=hy(:);
    end
    toc
end
%
hyo=mean(Ho,2);
hxx=hx(1:end-1)+dx/2;
%
Nnorm=2*dx*nsim/Rmax^2;
%
figure(1)
plot(hxx,hyo(1:end-1),'ko-')
line(hxx, hxx*Nnorm,...
    'color','k','linestyle','--','linewidth',2)
xlabel('Distance [m]')
ylabel('Click count')
