%Scr9_6
%
%heading distribution
dg=0.01;
gam=-pi:dg:pi;
k=5;
wg=1/(2*pi*besseli(0,k))*exp(k*cos(gam));
%estimate CDF
cwg=cumsum(wg)*dg;
%
%simulate random heading
rand('state',1)
nsim=1000000;
arg=rand(nsim,1);
%
[i1,i2,i3]=unique(cwg);
gamx=gam(i3);
cwgx=cwg(i3);
head=interp1(cwgx,gamx,arg,'lin','extrap');
%
% obtain histogram (PDF) of simulated heading
hx=gam;
hy=histc(head,hx); hy=hy/sum(hy);

isi=0.8;
isl=find(cwg>=isi,1,'first');

figure(1)
set(gcf,'position',[300 400 700 420])
subplot(121)
plot(gam*180/pi,cwg*100,'k')
line([-180 gam(isl) gam(isl)]*180/pi,...
      isi*[1 1 0]*100,'color','k','linestyle','--')
xlim([-180 180])
ylim([0 109])
xlabel('Heading [ ^o]')
ylabel('CDF [%]')
box on

subplot(122)
%bar(hx*180/pi,hy*100,'facecolor','w','edgecolor','k','barwidth',1);
plot(hx(1:10:end)*180/pi,hy(1:10:end)*100,'k*');
line(gam*180/pi,wg*dg*100,'color','k')
set(gca,'yaxislocation','right')
xlim([-180 180])
xlabel('Heading [ ^o]')
ylabel('PDF [%]')
box on
