%ScrF10_1
addpath('electronic')
figure(1)
clf
%test=true;
test=false;
if test
    grid on
else
    set(gca,'visible','off')
    set(gca,'position',[0 0 1 1])
end
axis equal
%
resistor('position',[1 2])
text('String','R_m',...
   'Position',[1.5 2.3],...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','left',...
   'VerticalAlignment','middle');

inductor('position',[2 2])
text('String','L_m',...
   'Position',[2.5 2.3],...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','bottom');

capacitor('position',[3 2])
text('String','C_m',...
   'Position',[3.5 2.3],...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','bottom');

capacitor('position',[4 2],'angle',-90)
text('String','C_0',...
   'Position',[4.3 1.5],...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','left',...
   'VerticalAlignment','middle');

% hydropone voltage
AC_Source('Position',[1 1.5],'String','V_{hyd}')
if 0
rectangle('Position',[1-0.15, 1.5-0.15, 0.3 0.3],'Curvature',[1,1],...
          'linewidth',2)
text('String','V_{hyd}',...
   'Position',[1-0.17 1.5],...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','right',...
   'VerticalAlignment','middle');
text('String','+',...
   'Position',[1+0.01 1.5+0.15],...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','left',...
   'VerticalAlignment','bottom');
end
wire('XData',[1 1],'YData',[1 1.5-0.15])
wire('XData',[1 1],'YData',[1.5+0.15 2])

wire('xdata',[4 4.5],'ydata',[2 2])
wire('xdata',[1 4.5],'ydata',[1 1])

line('XData',[4 4],'YData',[1 2],'Color','k',...
    'Marker','o','MarkerSize',6,'MarkerFaceColor','k',...
    'LineStyle','none')

% mark hydrophone
line('XData',[0.65 4.5 4.5 0.65 0.65],'YData',[0.5 0.5 2.7 2.7 0.5],'Color','k',...
    'Linestyle','--','LineWidth',1)

text('String','Hydrophone',...
   'Position',[1.5 2.8],...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','bottom');

port('xdata',4.5,'ydata',2,'name','U_1','Position',[0.1 +0.05])
port('xdata',4.5,'ydata',1,'name','GND','Position',[0.15 -0.15])


resistor('position',[5 2],'Angle',-90)
text('String','R_1',...
   'Position',[5.35 1.5],...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','right',...
   'VerticalAlignment','middle');
wire('xdata',[4.5 5 NaN 4.5 5],'ydata',[1 1 NaN 2 2])

set(gcf,'position',[360 500 700 420])
axis([0.5 5.6 0.3 3])
