function [ya ntr]=doAssoc2(ye,ym,yn1,yn2,yl,yb,ntr,th,mx)
% handle case that we have measurements but no tracks
if isempty(ye)
    yln=ntr+(1:length(ym))'; ntr=ntr+length(ym);
    ya=[ym ym 0*ym 0*ym yln 0*ym 1+0*ym];
    return
end
% handle case that we have tracks but no measurements
if isempty(ym)
    ya=[ye ye yn1 yn2 yl yb-1 2+0*ye];
    return
end
%
% standard case
% difference matrix
E=ym*ones(1,length(ye))-ones(length(ym),1)*ye';
%
% locate row-wise and column-wise minima
[E1,I1]=min(abs(E),[],1);
[E2,I2]=min(abs(E),[],2);
%
% estimate back-pointers in column form
I21=I2(I1); I21=I21(:); 
I12=I1(I2); I12=I12(:);
%
% find new and idle tracks
F1=~(E1<th & I21'==(1:length(I1)));
F2=~(E2<th & I12==(1:length(I2))');
%
if 0
    [0,    ye', 0,  0,  0;
     ym,abs(E), E2,I2, F2;
     0,     E1, 0,  0,  0;
     0,     I1, 0,  0,  0;
     0,     F1, 0,  0,  0]
end
%
% allocate new track labels
if ~isempty(ym(F2))
    yln=ntr+(1:length(ym(F2)))'; ntr=ntr+length(ym(F2));
else
    yln=0*ym(F2);
end
%
%generate association matrix
% use I2(~F2), ~F2 pair for continuated track
% could use also I1(~F1), ~F1 pair
I3=I2(~F2); 
%
ya=[ye(I3), ym(~F2), yn1(I3), yn2(I3), yl(I3),  0*yb(I3),   0*ym(~F2); 
    ym(F2),  ym(F2),  0*yln,  0*yln,   yln,  0*ym(F2),  1+0*ym(F2); 
    ye(F1),  ye(F1), yn1(F1), yn2(F1), yl(F1),  yb(F1)-1,  2+0*ye(F1)];
%
%prune shorties
ifl=ya(:,6)<-mx;
ya(ifl,:)=[];
%
return
