function np=doCluster(X,K)
%
[N,M]=size(X);
vv=zeros(M,1);
%
np=mod((0:N-1)',K)+1;
%
cv=zeros(1,K);
kct=zeros(1,K);
cm=zeros(M,K);
%
ind=0;
%
for kk=1:K
    nn=(np==kk);
    kct(kk)=sum(nn);
    if kct(kk)>0
        cm(:,kk)=mean(X(nn,:))';
    end
end
%
noshift=0;
loop=true;
while loop
    for ii=1:N
        noshift=noshift+1;
        if noshift>N, loop=false; break, end
        % get actual cluster
        npi=np(ii);
        if kct(npi)<=1, continue, end
        %
        %estimate variance by removing pivot sample
        vv1=sum((cm(:,npi)'-X(ii,:)).^2)...
            *kct(npi)/(kct(npi)-1);
        
        % find cluster with best improvement
        vmin=inf;
        for jj=1:K
            if jj==np(ii), continue, end
            %estimate variance by adding pivot sample
            vv2=sum((cm(:,jj)'-X(ii,:)).^2)...
                *kct(jj)/(kct(jj)+1);
            if vv2<=vmin
                vmin=vv2;
                npneu=jj;
            end
        end
        
        if vmin<vv1
            %change cluster 
            noshift=0;
            %
            cm(:,npi)  =...
                (kct(npi)  *cm(:,npi)  -X(ii,:)')/(kct(npi)-1);
            cm(:,npneu)=...
                (kct(npneu)*cm(:,npneu)+X(ii,:)')/(kct(npneu)+1);
            %
            np(ii)=npneu;
            kct(npi)=kct(npi)-1;
            kct(npneu)=kct(npneu)+1;
        end
    end
end
