function AC_Source(varargin)
%JFET  Draw a Junction FET

%---Default properties
p = struct(...
   'Parent',[],...
   'Position',[2 2],...
   'String','V_{AC}',...
   'Size',1,...
   'Angle',0,...
   'LineWidth',2,...
   'LineStyle','-',...
   'Color','k',...
   'Tag','',...
   'Clipping','off');
plist = fieldnames(p);

%---Merge user-specified properties
for i=1:2:nargin-1
   Property = pnmatch(varargin{i},plist);
   Value = varargin{i+1};
   p.(Property) = Value;
end
if isempty(p.Parent), p.Parent = gca; end

sz=p.Size*[-0.15 -0.15 0.3 0.3];
dx=p.Size*[.5];
dx=p.Size*[.3];
dy=p.Size*[0];

aa=p.Angle*pi/180;

zz=[cos(aa) -sin(aa); sin(aa) cos(aa)]*[dx;dy];


rectangle('Position',[p.Position 0 0]+sz,'Curvature',[1,1],...
          'linewidth',2)
text('String',p.String,...
   'Position',p.Position+zz',...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','middle');
%
f=0:0.1:1;
xsin=(f-0.5)/5; ysin=0.05*sin(2*pi*f);
wire('Xdata',p.Position(1)+xsin,'Ydata',p.Position(2)+ysin)
