function Current_Source(varargin)
%JFET  Draw a Junction FET

%---Default properties
p = struct(...
   'Parent',[],...
   'Position',[2 2],...
   'String','I_n',...
   'Size',1,...
   'Angle',0,...
   'LineWidth',2,...
   'LineStyle','-',...
   'Color','k',...
   'Tag','',...
   'Clipping','off');
plist = fieldnames(p);

%---Merge user-specified properties
for i=1:2:nargin-1
   Property = pnmatch(varargin{i},plist);
   Value = varargin{i+1};
   p.(Property) = Value;
end
if isempty(p.Parent), p.Parent = gca; end
%
sz=p.Size*[-0.15 -0.15 0.3 0.3];
dx=p.Size*(-0.1+[0 0 NaN -0.1 0 0.1]);
dy=p.Size*[-0.1 0.1 NaN 0 0.1 0];
%
r = 0.5*sqrt(dx.^2+dy.^2);
a0 = atan2(dy,dx);

rectangle('Position',[p.Position 0 0]+sz,'Curvature',[1,1],...
          'linewidth',2)
line(...
   'Parent',p.Parent,...
   'XData',p.Position(1)+r.*cos(a0+p.Angle*pi/180),...
   'YData',p.Position(2)+r.*sin(a0+p.Angle*pi/180),...
   'linewidth',2)

aa=p.Angle*pi/180;
zz=p.Size*[cos(aa) -sin(aa); sin(aa) cos(aa)]*[0.05 0]';

text('String',p.String,...
   'Position',p.Position+zz',...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','middle');
