function DC_Source(varargin)
%JFET  Draw a Junction FET

%---Default properties
p = struct(...
   'Parent',[],...
   'Position',[2 2],...
   'Size',1,...
   'String','V_{DC}',...
   'Angle',0,...
   'LineWidth',2,...
   'LineStyle','-',...
   'Color','k',...
   'Tag','',...
   'Clipping','off');
plist = fieldnames(p);

%---Merge user-specified properties
for i=1:2:nargin-1
   Property = pnmatch(varargin{i},plist);
   Value = varargin{i+1};
   p.(Property) = Value;
end
if isempty(p.Parent), p.Parent = gca; end

sz=p.Size*[-0.15 -0.15 0.3 0.3];
%
dx=p.Size*[0 0];
dy=p.Size*[0.1 -0.1];
%
r = sqrt(dx.^2+dy.^2);
a0 = atan2(dy,dx);

aa=p.Angle*pi/180;

zz=[cos(aa) -sin(aa); sin(aa) cos(aa)]*[dx;dy];

rectangle('Position',[p.Position 0 0]+sz,'Curvature',[1,1],...
          'linewidth',2)
text('String',p.String,...
   'Position',p.Position,...
   'FontSize',12,...
   'FontWeight','bold',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','middle');
text('String','+',...
   'Position',p.Position+zz(:,1)',...
   'FontSize',14,...
   'FontWeight','bold',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','middle');
text('String','-',...
   'Position',p.Position+zz(:,2)',...
   'FontSize',14,...
   'FontWeight','bold',...
   'HorizontalAlignment','center',...
   'VerticalAlignment','middle');

