function [xe,ye]=jfet(varargin)
%JFET  Draw a Junction FET

%---Default properties
p = struct(...
   'Parent',[],...
   'Position',[2 2],...
   'Size',1,...
   'Angle',0,...
   'LineWidth',2,...
   'LineStyle','-',...
   'Color','k',...
   'Tag','',...
   'Clipping','off');
plist = fieldnames(p);

%---Merge user-specified properties
for i=1:2:nargin-1
   Property = pnmatch(varargin{i},plist);
   Value = varargin{i+1};
   p.(Property) = Value;
end
if isempty(p.Parent), p.Parent = gca; end

%---Draw a line
x = p.Size*[0 .4 NaN 0.3 0.4 0.3 NaN .4   .4  NaN  .4  .6  .6 NaN .4 .6 .6];
y = p.Size*[0  0 NaN -.05 0.0 0.05 NaN -.05 .25 NaN  0    0 -.4 NaN .2 .2 .6];
r = sqrt(x(2:end).^2+y(2:end).^2);
a0 = atan(y(2:end)./x(2:end));
line(...
   'Parent',p.Parent,...
   'XData',p.Position(1)+[0 r.*cos(a0+p.Angle*pi/180)],...
   'YData',p.Position(2)+[0 r.*sin(a0+p.Angle*pi/180)],...
   'LineWidth',p.LineWidth,...
   'LineStyle',p.LineStyle,...
   'Color',p.Color,...
   'Tag',p.Tag,...
   'Clipping',p.Clipping);
xo=.4;
yo=.075;
ro = sqrt(xo.^2+yo);
ao = atan(yo./xo);

rectangle('Position',[p.Position(1)+ro.*cos(ao+p.Angle*pi/180)-0.25, ...
                      p.Position(2)+ro.*sin(ao+p.Angle*pi/180)-0.25, 0.5 0.5],'Curvature',[1,1],...
          'linewidth',2)
 
xe=p.Position(1)+[0 x(13) x(17)];
ye=p.Position(2)+[0 y(13) y(17)];
