function [sv,T,S]=getSoundSpeed(month,lat0,lng0)
%month=8;
%lat0=41;
%lng0=5;
%    
root0='../climatology/';
%
Leroy = @(T,S,Z,L) ...
        1402.5 + 5*T -(T/4.288).^2 +(T/16.8).^3 ...
        +(1.33 -(T/81.3) +(T/107.2).^2).*S ...
        +(Z/64.1) +(Z/1980.3).^2 -(Z/5155).^3 ...
        +(Z/18519).*(L/45-1)-T.*(Z/10172).^3 ...
        +((T/57.74).^2 +(S/69.93)).*(Z/1000);
%
lfn=sprintf('ts_%02d_1d',month);
if exist([lfn '.mat'],'file')~=2
    % extract data from climatology
    %
    temp=[];
    root1=sprintf('t_%02d_1d/',month);
    dirs=dir([root0 root1 '*.csv']);
    %
    for ii=1:length(dirs)
        fname=[root0 root1 dirs(ii).name];
        fprintf('loading %s\n',fname)
        temp(ii).dat=xlsread(fname,'A:D');
    end

    sal=[];
    root1=sprintf('s_%02d_1d/',month);
    dirs=dir([root0 root1 '*.csv']);
    %
    for ii=1:length(dirs)
        fname=[root0 root1 dirs(ii).name];
        fprintf('loading %s\n',fname)
        sal(ii).dat=xlsread(fname,'A:D');
    end
    % save data to local mat file
    save(lfn,'temp','sal')
end
%
%load local mat file to access data
load(lfn)
%
%extract temperature and salinity vector
T=zeros(length(temp),1);
D=0*T;
S=0*T;

for ii=1:length(temp)
    data=temp(ii).dat;
    gd=find(abs(data(:,1)-lat0)<=1 & abs(data(:,2)-lng0)<=1);
    %
    % temperature
    T(ii)=mean(data(gd,4));
    % depth
    D(ii)=mean(data(gd,3));
    % salinity
    S(ii)=mean(sal(ii).dat(gd,4));
end

%estimate sound speed
sv=[D,Leroy(T,S,D,lat0)];
